# rss_cralwer03

# v03 - Guardar data e url + excepção por erro do parser

Dir.chdir(File.dirname(__FILE__))


require 'rubygems'
require 'hpricot'
#require 'nokogiri'
require 'open-uri'
require 'feed-normalizer'
require 'lib/reco_fun.rb'
require 'date'

#$KCODE = 'n'

SRC_DIRECTORY = "src" # Where is the directory with the files
CORPUS_DIRECTORY = "corpus" # Where is the directory for the corpus
DATA_DIRECTORY = "data" # Where is the directory for the internal program data (like visited urls)
LOG_DIRECTORY = "log" # Where is the reports of the executions

Dir.chdir(File.dirname(__FILE__))



############## SOURCE CLASS
# Represents the newspaper, web ot whatever information source
class Source
	attr_reader :saved_posts,	:new_urls, :urls_from_feed, :words

	# Build method
	def initialize(file)
		@rss_url_list = Array.new

		file.each_with_index do |line,index|
			line = line.chomp # Delete the last \n
			if index == 0
				@name = line.gsub(" ","")
			elsif index == 1
				@linguas = line.split(" ")
			elsif index == 2
				@categoria_xpath = line
			elsif index == 3			
				@titulo_xpath = line
			elsif index == 4
				@subtitulo_xpath = line
			elsif index == 5
				@texto_xpath = line
			else
				@rss_url_list << line
			end
		end

		@corpus_files = Array.new
		@linguas.each do |lingua|
			@corpus_files << File.new("#{CORPUS_DIRECTORY}/#{@name}_#{lingua}_corpus.txt","a+")
		end
		@visited_urls_file = File.new("#{DATA_DIRECTORY}/#{@name}_visited_urls.txt","a+")
		@visited_urls = Array.new
		@visited_urls_file.each_with_index do |line, i| 
			@visited_urls << line.chomp 
			break if i > 1000 # Controla que o array de visitados não seja enoorme
		end

		# Reporting data
		@saved_posts = 0
		@new_urls = 0
		@urls_from_feed = 0
		@words = 0
	end

	# Access to a list of urls, find and save information ## This is the method to call from outside ##
	def update_corpus
		# Writing log
		puts_log "################ #{@name}"
		puts_log_error "################ #{@name}"
		list = get_new_urls

		@urls_from_feed = list.size
		list.each do |url_date|
			url = url_date[0]
			date = url_date[1]
			if first_time? url
				@new_urls += 1
				if (save(url_date)) != nil
					@saved_posts += 1
					puts_log "* #{url}"
					add_url url
				else
					puts_log "- #{url}"
				end
			else
				puts_log "_ #{url}"
			end
		end
		$general_report.puts "#{Date.today.to_s}".ljust(14) + @name.ljust(20) + "Words added: #{@words}".ljust(25) + "Saved articles: #{@saved_posts}".ljust(25) + "New urls: #{@new_urls}".ljust(25) + "Urls from feed: #{@urls_from_feed}".ljust(25)
	end

	# Testing the first urls
	def test
		list = get_urls
		list.each_with_index do |url,index|
			if index >= 5
				break
			end
			doc = Hpricot(open(url))
			#doc =  Nokogiri::HTML(open(url))
			puts "\n\n\n#{@name} - #{url}"
			if @categoria_xpath != ""
				puts "CATEGORIA<<#{limpar_html(doc.search(@categoria_xpath).inner_html)}>>"
			end
			puts "TITULO<<#{limpar_html(doc.search(@titulo_xpath).inner_html)}>>"
			if @subtitulo_xpath != ""
				puts "SUBTITULO<<#{limpar_html(doc.search(@subtitulo_xpath).inner_html)}>>"
			end
			puts "TEXTO<<#{limpar_html(doc.search(@texto_xpath).inner_html)}>>"
		end
	end

	private

	# Give a list (array) of urls from all the RSS files
	def get_urls
		list = Array.new
		@rss_url_list.each do |rss_url|
			rss = get_rss rss_url
			if rss == nil
				next
			end
			rss.items.each do |entry|
				list << [entry.urls.first,entry.date_published]
			end
		end
		list
	end
		
	# Give a list (array) of NEW urls from the RSS files
	def get_new_urls
		final_list = Array.new
		list = get_urls
		list.each do |entry|
			final_list << entry
		end
		final_list
	end

	# Return true if an url was not already crawled
	def first_time? (url)
		not @visited_urls.include?(url)
	end

	# Add the url to the visited urls
	def add_url(url)
		@visited_urls_file.puts url
	end

	# Save
	def save(url_date)
		url = url_date[0]
		date = url_date[1]
		html = my_open_url(url)
		
		if html == nil || html == ""
			puts_log_error "Error in function save, call the programmer"
			return nil
		end
		begin
			doc = Hpricot(html)
			#doc = Nokogiri::HTML(html)
		rescue => e
			puts_log_error "Error parsing loading: " + $!
			return nil
		end
		
		begin
			categoria = limpar_brancos(limpar_html(doc.search(@categoria_xpath).inner_html))
			titulo = limpar_brancos(limpar_html(doc.search(@titulo_xpath).inner_html))
			subtitulo = limpar_brancos(limpar_html(doc.search(@subtitulo_xpath).inner_html))
			texto = limpar_brancos(limpar_html(doc.search(@texto_xpath).inner_html))
		rescue
			puts_log_error "Error in parsing process: " + $!
			return nil
		end

		# Se o subtitulo (ou categoria) esta valeiro guardase um espaço em branco
		if @subtitulo_xpath == "" || subtitulo == nil
			subtitulo = " "
		end
		if @categoria_xpath == "" || categoria == nil
			categoria = " "
		end

		# Comprobamos que nom houbo falhos na leitura dos campos
		if (titulo == nil || subtitulo == nil || texto == nil) || (vazio_ou_branco?(titulo) && vazio_ou_branco?(texto))
			puts_log_error "Error in scrapper (no title or no text) or any field nil"
			return nil
		else


			# Escolha da lingua
			if @linguas.size == 1
				corpus_file = @corpus_files[0]
			else
				if (@linguas.index(reco(texto)) == nil)
					puts_log_error "Language unknow"
					return nil
				end
				corpus_file = @corpus_files[@linguas.index(reco(texto))]
			end

			# Gravamos no ficheiro de saida				 
			corpus_file.puts "<article>"
			corpus_file.puts "<date>" + date.to_s + "</date>"
			corpus_file.puts "<url>" + url + "</url>"
			corpus_file.puts "<category>" + categoria.chomp + "</category>"
			corpus_file.puts "<title>" + titulo.chomp + "</title>"
			corpus_file.puts "<subtitle>" + subtitulo + "</subtitle>"
			corpus_file.puts "<text>" + texto + "</text>"
			corpus_file.puts "</article>"

			# Add reporting data
			@words += texto.split(" ").size
		end
	end

	def get_rss(feed_url)
		feed_content = my_open_url(feed_url)
		rss = FeedNormalizer::FeedNormalizer.parse feed_content
	end
	
	def my_open_url(url)
		begin
			content = open(url)
		rescue => e
			puts_log_error "Erro abrindo a url #{url}"
			content = nil
		rescue Timeout::Error => e
			puts_log_error "Timeout abrindo a url #{url}"
			content = nil
		end
		content
	end


	# Funçom que devolve true si esta vacio ou se contem espaços en branco (ou se é nil)
	def vazio_ou_branco?(cadea)
		if cadea == nil
			return true
		end
		if cadea == ""
			return true
		end
		while cadea[1] != nil
			if cadea[0..0] != " " && cadea[0..0] != "\n" && cadea[0..0] != "\t" # Si é distinto do espaço branco, do salto de linha e do tabulador
				return false
			end
			cadea = cadea[1..-1]
		end
		return true
	end

	# Esta funcao nao perdeu o seu sentido porque ainda que já que obtemos o html sem tags com inner_text, para alguns jornais nao trata bem os simbolos raros
	# Limpa a cadea entrante e devólvea sem os tag ("<calqueracousa">) e convertindo os &ntilde; e similares
	def limpar_html(cadea)	
		# limpamos os tags html
		cadea = cadea.gsub(/<\/?[^>]*>/, "")

		Convercom_html.each do |c|
			cadea = cadea.gsub(c[0], c[1])
		end
		cadea
	end

	# Esta funçao é a funçao strip, no futuro ha que remover esto
	# Clean white spaces (tabs and newlines) before and after last letters
	def limpar_brancos(cadea)
		if cadea == nil
			return cadea
		end
		while cadea[0..0] == " " || cadea[0..0] == "\t"
			cadea = cadea[1..-1]
		end
		while cadea[-1..-1] == " " || cadea[-1..-1] == "\n" || cadea[-1..-1] == "\t"
			cadea = cadea[0..-2]
		end
		cadea
	end	

	# Log methods
	def puts_log cadea
		$log_file.puts cadea
		puts cadea
	end
	def print_log cadea
		$log_file.print cadea
		print cadea
	end
	# Log_error method
	def puts_log_error cadea
		$log_error_file.puts cadea
		puts cadea
	end
end




############## MAIN


#Precode
if not File::exist? CORPUS_DIRECTORY
	Dir.mkdir(CORPUS_DIRECTORY)
end
if not File::exist? DATA_DIRECTORY
	Dir.mkdir(DATA_DIRECTORY)
end
if not File::exist? LOG_DIRECTORY
	Dir.mkdir(LOG_DIRECTORY)
end
# Log files
$log_file = File.new("#{LOG_DIRECTORY}/#{Date.today.to_s}_log.txt","a+")
$log_error_file = File.new("#{LOG_DIRECTORY}/#{Date.today.to_s}_log_error.txt","a+")
$general_report = File.new("#{LOG_DIRECTORY}/general_report.txt","a+")


# If SRC_DIRECTORY doesn't exist, creates. Then open
if not File::exist? SRC_DIRECTORY
	Dir.mkdir(SRC_DIRECTORY)
end
dir = Dir.open(SRC_DIRECTORY)
# Caracteres especiais
Convercom_html = [[/&nbsp;/," "],[/&Agrave;/,"À"],[/&Aacute;/,"Á"],[/&Acirc;/,"Â"],[/&Atilde;/,"Ã"],[/&Ograve;/,"Ô"],[/&Ccedil;/,"Ç"],[/&Eacute;/,"É"],[/&Ecirc;/,"Ê"],[/&Iacute;/,"Í"],[/&Ntilde;/,"Ñ"],[/&Oacute;/,"Ó"],[/&Ocirc;/,"Ô"],[/&Otilde;/,"Õ"],[/&Uacute;/,"Ú"],[/&agrave;/,"á	"],[/&aacute;/,"á"],[/&acirc;/,"â"],[/&atilde;/,"ã"],[/&ccedil;/,"ç"],[/&eacute;/,"é"],[/&ecirc;/,"ê"],[/&iacute;/,"í"],[/&ntilde;/,"ñ"],[/&ograve;/,""],[/&oacute;/,"ó"],[/&ocirc;/,"ô"],[/&otilde;/,"õ"],[/&uacute;/,"ú"],[/&uuml;/,"ü"],[/&ordm;/,"º"],[/&iquest;/,"¿"],[/&laquo;/,"«"],[/&raquo;/,"»"],[/&ldquo;/,'"'],[/&rdquo;/,'"'],[/&quot;/,'"'],[/&lsquo;/,'"'],[/&rsquo;/,'"'],["","-"],["",'"'],["",'"'],["&#039;",'"']]

#Hpricot.buffer_size = 262144 # Increase the buffer of Hpricot library, if an bufffer error about it produces then increase this number

# Iterate the entries of the source directory (like ls), create the objects with that info and put it into the array
sources = Array.new
dir.each do |entry|
	if entry == "." || entry == ".." || entry[-1..-1] == "~" || entry[-5..-1] != ".conf"
		next
	end
	sources << Source.new(File.open(SRC_DIRECTORY + "/" + entry))
end


#OPTIONS -t test
if ARGV[0] == "-t"
	# Execute a provethe sources
	sources.each do |source|
		source.test
	end
else
	ti = Time.now
	words,saved_posts, new_urls, urls_from_feed = 0, 0, 0, 0
	# Execute the sources
	sources.each do |source|
		source.update_corpus

		words += source.words
		saved_posts += source.saved_posts
		new_urls += source.new_urls
		urls_from_feed += source.urls_from_feed
	end
	puts "Time: #{(Time.now - ti).to_i} seconds"
		$general_report.puts "#{Date.today.to_s}".ljust(14) + "TOTAL".ljust(20) + "Words added: #{words}".ljust(25) + "Saved articles: #{saved_posts}".ljust(25) + "New urls: #{new_urls}".ljust(25) + "Urls from feed: #{urls_from_feed}".ljust(25)
	$general_report.puts "Inicio: #{Time.now}".ljust(54,"-") + "     Time: #{(Time.now - ti).to_i/60} minutes     ".center(80,"-")
end


